<template>
    <v-container grid-list-md>
        <v-layout row wrap align-center>

            <v-flex xs12 md6>
                <v-select
                        v-model="selectedTeacher"
                        :items="teacherNames"
                        label="Lehrperson auswählen..."
                        solo
                        @change="changeTeacher"
                ></v-select>
            </v-flex>

            <v-flex xs12 md6>
                <v-select
                        :disabled="teacherSubjects.length <= 0"
                        v-model="selectedSubjects"
                        :items="teacherSubjects"
                        label="Fächer"
                        solo
                        chips
                        multiple
                        @change="loadData"
                ></v-select>
            </v-flex>

            <v-flex xs12 v-if="Object.keys(teacherRatings).length > 0">
                <v-card>
                    <v-card-title>
                        <h2 class="headline">Beste Ratings</h2>
                    </v-card-title>
                    <v-card-text>
                        <v-list>
                            <template v-for="(item, index) in bestRatings">
                                <v-list-tile :key="index" avatar>
                                    <v-list-tile-action>
                                        <v-avatar color="primary">
                                            <span class="white--text">{{ item.average.toFixed(2) }}</span>
                                        </v-avatar>
                                    </v-list-tile-action>

                                    <v-list-tile-content>
                                        <v-list-tile-title>
                                            {{ item.questionText }}
                                        </v-list-tile-title>
                                    </v-list-tile-content>
                                </v-list-tile>
                            </template>
                        </v-list>
                    </v-card-text>
                </v-card>
            </v-flex>

            <v-flex xs12 v-if="Object.keys(teacherRatings).length > 0">
                <v-card>
                    <v-card-title>
                        <h2 class="headline">Schlechteste Ratings</h2>
                    </v-card-title>
                    <v-card-text>
                        <v-list>
                            <template v-for="(item, index) in worstRatings">
                                <v-list-tile :key="index" avatar>
                                    <v-list-tile-action>
                                        <v-avatar color="primary">
                                            <span class="white--text">{{ item.average.toFixed(2) }}</span>
                                        </v-avatar>
                                    </v-list-tile-action>

                                    <v-list-tile-content>
                                        <v-list-tile-title>
                                            {{ item.questionText }}
                                        </v-list-tile-title>
                                    </v-list-tile-content>
                                </v-list-tile>
                            </template>
                        </v-list>
                    </v-card-text>
                </v-card>
            </v-flex>

            <v-flex xs12 v-if="teacherRemarks.length > 0">
                <v-card>
                    <v-card-title>
                        <h2 class="headline">Bemerkungen</h2>
                    </v-card-title>
                    <v-card-text>
                        <v-list>
                            <template v-for="(remark, index) in teacherRemarks">
                                <v-list-tile :key="index">
                                    <v-list-tile-content>
                                        <v-list-tile-title>
                                            {{ remark.remarks }}
                                        </v-list-tile-title>
                                    </v-list-tile-content>
                                </v-list-tile>
                            </template>
                        </v-list>
                    </v-card-text>
                </v-card>
            </v-flex>

        </v-layout>
    </v-container>


</template>

<script lang="ts">
    // eslint-disable-next-line no-unused-vars
    import {db} from '../main'

    export default {
        data: () => ({
            teacherNames: [],
            selectedTeacher: null,
            teacherRatings: {},
            teacherRemarks: [],
            teacherSubjects: [],
            selectedSubjects: [],
        }),
        computed: {
            bestRatings() {
                return this.getSortedRatings([-3]);
            },
            worstRatings() {
                return this.getSortedRatings([0, 3]);
            },
        },

        mounted() {
            this.$emit('updateToolbarTitle', 'Resultate');

            /**
             * TODO: Continuously retrieve answers for all teachers
             *       and provide the snapshot to the fillInTeacherNames function.
             *
             * Hint: Is there a better way than retrieving (and processing) all documents? Maybe some filtering?
             */

        },

        methods: {
            fillInTeacherNames(querySnapshot) {
                const component = this;
                querySnapshot.forEach(function (document) {
                    const teacherName = document.data()['teacher'];
                    if (component.teacherNames.indexOf(teacherName) < 0) {
                        component.teacherNames.push(teacherName);
                    }
                });
            },

            // eslint-disable-next-line no-unused-vars
            changeTeacher(newTeacher) {

                /**
                 * TODO: Retrieve (as efficient as possible) a snapshot of documents for the given newTeacher.
                 *       Submit the retrieved documents to the extractSubjects function.
                 */

            },

            loadData() {

                /**
                 * TODO: Retrieve all answers for the currently selected teacher and submit the QuerySnapshot to the
                 *       selectedTeacher function.
                 */


                // WARNING: Before you go on --> Make sure you accomplished all other tasks!

                /**
                 * TODO: Respect the users selection regarding the teachers subjects: Do only retrieve answers which
                 *       match the selected subjects.
                 *
                 * Hint: This task is fairly complex! Make up your own plan to achieve the goal. Discuss this plan with
                 *       your teacher before you start implementing...
                 */

            },

            processAnswers(answersSnapshot) {
                let groupedAnswers = this.groupBy(answersSnapshot, 'questionId');
                let aggregatedRatings = Object.entries(groupedAnswers).reduce(this.aggregateAnswers, {});
                this.$set(this, 'teacherRatings', aggregatedRatings);
                this.$set(this, 'teacherRemarks', this.extractRemarks(groupedAnswers));
            },

            groupBy(ratingsQuerySnapshot, field) {
                return ratingsQuerySnapshot
                    .map((document) => document.data())
                    .reduce(function (result, ratingDocument) {
                        result[ratingDocument[field]] = result[ratingDocument[field]] || [];
                        result[ratingDocument[field]].push(ratingDocument);
                        return result;
                    }, {});
            },

            aggregateAnswers(result, [questionId, answers]) {
                if (questionId !== 'remarks') {
                    let questionsIdentifiers = questionId.split('-');
                    let aggregatedForm = {
                        questionCategory: questionsIdentifiers[0],
                        questionIndex: parseInt(questionsIdentifiers[1]),
                        count: 0,
                        average: 0
                    };
                    result[questionId] = answers.reduce(this.calculateAverageRating, aggregatedForm);
                }
                return result;
            },

            calculateAverageRating(tempResult, answer, index, answers) {
                if (answer.hasOwnProperty('rating')) {
                    tempResult.questionText = answer['questionText'];
                    tempResult.count += 1;
                    tempResult.average += (answer['rating'] / answers.length);
                }
                return tempResult;
            },

            extractRemarks(groupedAnswers) {
                return groupedAnswers['remarks'] || [];
            },

            extractSubjects(querySnapshots) {
                let subjects = querySnapshots.docs.map(document => document.data().subject);
                this.$set(this, 'teacherSubjects', [...new Set(subjects)]);
            },

            getSortedRatings(range) {
                let sorted = this.sortRatingsAscendingByAverage(Object.entries(this.teacherRatings));
                let excerpt = sorted.slice(...range);
                if (range[0] < 0) {
                    excerpt = excerpt.reverse();
                }
                return Object.fromEntries(excerpt);
            },

            // eslint-disable-next-line no-unused-vars
            sortRatingsAscendingByAverage(aggregatedRatings) {

                /**
                 * TODO: Sort the given aggregatedRatings ascending by their average rating value.
                 *
                 * Hint: The value of aggregatedRatings is an array of arrays.
                 *       Each inner array has two elements of which the first is the questionId
                 *       and the second contains the aggregated data object.
                 *       You might want to use the .sort function on arrays... :-)
                 */

            }
        }
    }
</script>

<style scoped>

</style>
